# $Revision: 1.135 $, $Date: 2008-03-31 22:02:14 $
#
# Conditional build:
%bcond_with	noarch		# build noarch packages
%bcond_with	verbose		# verbose build (V=1)
%bcond_with	pae		# build PAE (HIGHMEM64G) support on uniprocessor
%bcond_with	preempt-nort	# build preemptable no realtime kernel

%{?debug:%define with_verbose 1}

%ifnarch %{ix86}
%undefine	with_pae
%endif

%if "%{_arch}" == "noarch"
%define		with_noarch	1
%endif

%define		have_isa	1
%define		have_oss	1
%define		have_pcmcia	1
%define		have_sound	1
%define		have_drm	1

%ifnarch %{ix86} alpha ppc
%define		have_isa	0
%endif
%ifarch sparc sparc64
%define		have_drm	0
%define		have_oss	0
%define		have_pcmcia	0
%endif

%define		alt_kernel	vanilla

# Our Kernel ABI, increase this when you want out of source modules being rebuilt
%define		KABI		1
# Module.symvers: e05892f5d4e6f21d9456f4cdf02e6021

# kernel release (used in filesystem and eventually in uname -r)
# modules will be looked from /lib/modules/%{kernel_release}
# _localversion is just that without version for "> localversion"
%define		_localversion %{KABI}
%define		kernel_release %{version}_%{alt_kernel}-%{_localversion}
%define		_kernelsrcdir	/usr/src/linux-%{version}_%{alt_kernel}

%define		_basever	2.6.24
%define		_postver	.4
%define		_rel		1

# for rc kernels basever is the version patch (source1) should be applied to
#%define		_ver		2.6.20
#%define		_rc			rc4
# for non rc-kernels these should be %{nil}
%define		_ver		%{nil}
%define		_rc			%{nil}

Summary:	The Linux kernel (the core of the Linux operating system)
Summary(de.UTF-8):	Der Linux-Kernel (Kern des Linux-Betriebssystems)
Summary(fr.UTF-8):	Le Kernel-Linux (La partie centrale du systeme)
Summary(pl.UTF-8):	Jądro Linuksa
Name:		kernel-%{alt_kernel}
Version:	%{?_ver:%{_ver}}%{_basever}%{_postver}
Release:	%{?_rc:%{_rc}}%{_rel}
Epoch:		3
License:	GPL v2
Group:		Base/Kernel
Source0:	http://www.kernel.org/pub/linux/kernel/v2.6/linux-%{_basever}.tar.bz2
# Source0-md5:	3f23ad4b69d0a552042d1ed0f4399857
Source1:	http://www.kernel.org/pub/linux/kernel/v2.6/patch-%{_basever}%{_postver}.bz2
# Source1-md5:	508f5aaa99dead9836ff490496a61581
Source2:	kernel-vanilla-module-build.pl
Source3:	kernel-config.py
Source4:	kernel-config-update.py
Source5:	kernel-multiarch.make
Source6:	kernel-vanilla-config.h
Source7:	kernel-vanilla-multiarch.conf
Source8:	kernel-vanilla-preempt-nort.config
Source9:	kernel-vanilla-no-preempt-nort.config
Patch0:		kernel-mcpu=440.patch
URL:		http://www.kernel.org/
BuildRequires:	binutils >= 3:2.14.90.0.7
%ifarch sparc sparc64
BuildRequires:	elftoaout
%endif
BuildRequires:	%{kgcc_package} >= 5:3.2
BuildRequires:	module-init-tools
# for hostname command
BuildRequires:	net-tools
BuildRequires:	perl-base
BuildRequires:	rpmbuild(macros) >= 1.379
BuildRequires:	sed >= 4.0
Autoreqprov:	no
Requires:	/sbin/depmod
Requires:	coreutils
Requires:	geninitrd >= 2.57
Requires:	module-init-tools >= 0.9.9
Provides:	%{name}(vermagic) = %{kernel_release}
Conflicts:	e2fsprogs < 1.29
Conflicts:	isdn4k-utils < 3.1pre1
Conflicts:	jfsutils < 1.1.3
Conflicts:	module-init-tool < 0.9.10
Conflicts:	nfs-utils < 1.0.5
Conflicts:	oprofile < 0.9
Conflicts:	ppp < 1:2.4.0
Conflicts:	procps < 3.2.0
Conflicts:	quota-tools < 3.09
Conflicts:	reiserfsprogs < 3.6.3
Conflicts:	udev < 1:071
Conflicts:	util-linux < 2.10o
Conflicts:	xfsprogs < 2.6.0
ExclusiveOS:	Linux
%{?with_noarch:BuildArch:	noarch}
ExclusiveArch:	%{ix86} %{x8664} ppc alpha sparc noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%ifarch %{ix86} %{x8664}
%define		target_arch_dir	x86
%else
%define		target_arch_dir	%{_target_base_arch}
%endif

# No ELF objects there to strip (skips processing 27k files)
%define		_noautostrip	.*%{_kernelsrcdir}/.*
%define		_noautochrpath	.*%{_kernelsrcdir}/.*

%define		initrd_dir	/boot

%define		topdir	%{_builddir}/%{name}-%{version}
%define		srcdir	%{topdir}/linux-%{_basever}
%define		objdir	%{topdir}/o

%define		CommonOpts	HOSTCC="%{kgcc}" HOSTCFLAGS="-Wall -Wstrict-prototypes %{rpmcflags} -fomit-frame-pointer" O=%{objdir}
%if "%{_target_base_arch}" != "%{_arch}"
	%define	MakeOpts %{CommonOpts} ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux-
	%define	DepMod /bin/true

	%if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"
	%define	MakeOpts %{CommonOpts} CC="%{kgcc}" ARCH=%{_target_base_arch}
	%define	DepMod /sbin/depmod
	%endif

%else
	%define MakeOpts %{CommonOpts} CC="%{kgcc}"
	%define	DepMod /sbin/depmod
%endif

%define __features Enabled features:\
%{?debug: - DEBUG}\
%define Features %(echo "%{__features}
%{?with_pae: - PAE (HIGHMEM64G) support}" | sed '/^$/d')
# vim: "

%description
This package contains the Linux kernel that is used to boot and run
your system. It contains few device drivers for specific hardware.
Most hardware is instead supported by modules loaded after booting.

%{Features}

%description -l de.UTF-8
Das Kernel-Packet enthält den Linux-Kernel (vmlinuz), den Kern des
Linux-Betriebssystems. Der Kernel ist für grundliegende
Systemfunktionen verantwortlich: Speicherreservierung,
Prozeß-Management, Geräte Ein- und Ausgaben, usw.

%{Features}

%description -l fr.UTF-8
Le package kernel contient le kernel linux (vmlinuz), la partie
centrale d'un système d'exploitation Linux. Le noyau traite les
fonctions basiques d'un système d'exploitation: allocation mémoire,
allocation de process, entrée/sortie de peripheriques, etc.

%{Features}

%description -l pl.UTF-8
Pakiet zawiera jądro Linuksa niezbędne do prawidłowego działania
Twojego komputera. Zawiera w sobie sterowniki do sprzętu znajdującego
się w komputerze, takiego jak sterowniki dysków itp.

%{Features}

%package vmlinux
Summary:	vmlinux - uncompressed kernel image
Summary(de.UTF-8):	vmlinux - dekompressiertes Kernel Bild
Summary(pl.UTF-8):	vmlinux - rozpakowany obraz jądra
Group:		Base/Kernel

%description vmlinux
vmlinux - uncompressed kernel image.

%description vmlinux -l de.UTF-8
vmlinux - dekompressiertes Kernel Bild.

%description vmlinux -l pl.UTF-8
vmlinux - rozpakowany obraz jądra.

%package drm
Summary:	DRM kernel modules
Summary(de.UTF-8):	DRM Kernel Treiber
Summary(pl.UTF-8):	Sterowniki DRM
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description drm
DRM kernel modules

%description drm -l de.UTF-8
DRM Kernel Treiber

%description drm -l pl.UTF-8
Sterowniki DRM

%package pcmcia
Summary:	PCMCIA modules
Summary(de.UTF-8):	PCMCIA Module
Summary(pl.UTF-8):	Moduły PCMCIA
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Conflicts:	pcmcia-cs < 3.1.21
Conflicts:	pcmciautils < 004
Autoreqprov:	no

%description pcmcia
PCMCIA modules

%description pcmcia -l de.UTF-8
PCMCIA Module

%description pcmcia -l pl.UTF-8
Moduły PCMCIA

%package sound-alsa
Summary:	ALSA kernel modules
Summary(de.UTF-8):	ALSA Kernel Module
Summary(pl.UTF-8):	Sterowniki dźwięku ALSA
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-alsa
ALSA (Advanced Linux Sound Architecture) sound drivers.

%description sound-alsa -l de.UTF-8
ALSA (Advanced Linux Sound Architecture) Sound-Treiber.

%description sound-alsa -l pl.UTF-8
Sterowniki dźwięku ALSA (Advanced Linux Sound Architecture).

%package sound-oss
Summary:	OSS kernel modules
Summary(de.UTF-8):	OSS Kernel Module
Summary(pl.UTF-8):	Sterowniki dźwięku OSS
Group:		Base/Kernel
Requires:	%{name} = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description sound-oss
OSS (Open Sound System) drivers.

%description sound-oss -l de.UTF-8
OSS (Open Sound System) Treiber.

%description sound-oss -l pl.UTF-8
Sterowniki dźwięku OSS (Open Sound System).

%package config
Summary:	Kernel config and module symvers
Group:		Development/Building
Autoreqprov:	no
Conflicts:	rpmbuild(macros) < 1.433

%description config
Kernel config and module symvers.

%package headers
Summary:	Header files for the Linux kernel
Summary(de.UTF-8):	Header Dateien für den Linux-Kernel
Summary(pl.UTF-8):	Pliki nagłówkowe jądra Linuksa
Group:		Development/Building
Requires:	%{name}-config = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description headers
These are the C header files for the Linux kernel, which define
structures and constants that are needed when rebuilding the kernel or
building kernel modules.

%description headers -l de.UTF-8
Dies sind die C Header Dateien für den Linux-Kernel, die definierte
Strukturen und Konstante beinhalten die beim rekompilieren des Kernels
oder bei Kernel Modul kompilationen gebraucht werden.

%description headers -l pl.UTF-8
Pakiet zawiera pliki nagłówkowe jądra, niezbędne do rekompilacji jądra
oraz budowania modułów jądra.

%package module-build
Summary:	Development files for building kernel modules
Summary(de.UTF-8):	Development Dateien die beim Kernel Modul kompilationen gebraucht werden
Summary(pl.UTF-8):	Pliki służące do budowania modułów jądra
Group:		Development/Building
Requires:	%{name}-headers = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description module-build
Development files from kernel source tree needed to build Linux kernel
modules from external packages.

%description module-build -l de.UTF-8
Development Dateien des Linux-Kernels die beim kompilieren externer
Kernel Module gebraucht werden.

%description module-build -l pl.UTF-8
Pliki ze drzewa źródeł jądra potrzebne do budowania modułów jądra
Linuksa z zewnętrznych pakietów.

%package source
Summary:	Kernel source tree
Summary(de.UTF-8):	Der Kernel Quelltext
Summary(pl.UTF-8):	Kod źródłowy jądra Linuksa
Group:		Development/Building
Requires:	%{name}-module-build = %{epoch}:%{version}-%{release}
Autoreqprov:	no

%description source
This is the source code for the Linux kernel. It is required to build
most C programs as they depend on constants defined in here. You can
also build a custom kernel that is better tuned to your particular
hardware.

%description source -l de.UTF-8
Das Kernel-Source-Packet enthält den source code (C/Assembler-Code)
des Linux-Kernels. Die Source-Dateien werden gebraucht, um viele
C-Programme zu kompilieren, da sie auf Konstanten zurückgreifen, die
im Kernel-Source definiert sind. Die Source-Dateien können auch
benutzt werden, um einen Kernel zu kompilieren, der besser auf Ihre
Hardware ausgerichtet ist.

%description source -l fr.UTF-8
Le package pour le kernel-source contient le code source pour le noyau
linux. Ces sources sont nécessaires pour compiler la plupart des
programmes C, car il dépend de constantes définies dans le code
source. Les sources peuvent être aussi utilisée pour compiler un noyau
personnalisé pour avoir de meilleures performances sur des matériels
particuliers.

%description source -l pl.UTF-8
Pakiet zawiera kod źródłowy jądra systemu.

%package doc
Summary:	Kernel documentation
Summary(de.UTF-8):	Kernel Dokumentation
Summary(pl.UTF-8):	Dokumentacja do jądra Linuksa
Group:		Documentation
Autoreqprov:	no

%description doc
This is the documentation for the Linux kernel, as found in
Documentation directory.

%description doc -l de.UTF-8
Dies ist die Kernel Dokumentation wie sie im 'Documentation'
Verzeichniss vorgefunden werden kann.

%description doc -l pl.UTF-8
Pakiet zawiera dokumentację do jądra Linuksa pochodzącą z katalogu
Documentation.

%prep
%setup -qc
install -d o/scripts
ln -s %{SOURCE2} o/scripts/kernel-module-build.pl
ln -s %{SOURCE3} o/scripts/kernel-config.py
ln -s %{SOURCE4} o/scripts/kernel-config-update.py
ln -s %{SOURCE5} Makefile

cd linux-%{_basever}
%if "%{_postver}" != "%{nil}"
%{__bzip2} -dc %{SOURCE1} | %{__patch} -p1 -s
%endif

%patch0 -p1

# if we really want to have vanilla kernel we should create copy from Makefile
#cp Makefile{,.vanilla}

# Fix EXTRAVERSION in main Makefile
sed -i 's#EXTRAVERSION =.*#EXTRAVERSION = %{_postver}_%{alt_kernel}#g' Makefile

# cleanup backups after patching
find '(' -name '*~' -o -name '*.orig' -o -name '.gitignore' ')' -print0 | xargs -0 -r -l512 rm -f

%if %{without noarch}
%build
cat > multiarch.make <<'EOF'
# generated by %{name}.spec
KERNELSRC		:= %{_builddir}/%{name}-%{version}/linux-%{_basever}
KERNELOUTPUT	:= %{objdir}

SRCARCH		:= %{target_arch_dir}
ARCH		:= %{_target_base_arch}
Q			:= %{!?with_verbose:@}
MAKE_OPTS	:= %{MakeOpts}

CONFIGS += %{_sourcedir}/kernel-vanilla-multiarch.conf
%if %{with preempt-nort}
CONFIGS += %{_sourcedir}/kernel-vanilla-preempt-nort.config
%else
CONFIGS += %{_sourcedir}/kernel-vanilla-no-preempt-nort.config
%endif

# config where we ignore timestamps
CONFIG_NODEP += %{objdir}/.kernel-autogen.conf
EOF

# update config at spec time
# if you have config file, add it to above Makefile
pykconfig() {
	set -x
	echo '# %{name}.spec overrides'
	echo 'LOCALVERSION="-%{_localversion}"'

	%{?debug:echo '# debug options'}
	%{?debug:echo 'DEBUG_SLAB=y'}
	%{?debug:echo 'DEBUG_PREEMPT=y'}
	%{?debug:echo 'RT_DEADLOCK_DETECT=y'}

%ifarch %{ix86}
	echo '# x86 tuneup'
	%ifarch i386
	echo 'M386=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i486
	echo 'M486=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i586
	echo 'M586=y'
	echo 'X86_F00F_BUG=y'
	%endif
	%ifarch i686
	echo 'M686=y'
	%endif
	%ifarch pentium3
	echo 'MPENTIUMIII=y'
	%endif
	%ifarch pentium4
	echo 'MPENTIUM4=y'
	%endif
	%ifarch athlon
	echo 'MK7=y'
	echo 'X86_PPRO_FENCE='
	echo 'X86_USE_3DNOW=y'
	%endif
	%ifarch i686 athlon pentium3 pentium4
	%if %{with pae}
		echo 'HIGHMEM4G=n'
		echo 'HIGHMEM64G=y'
		echo 'X86_PAE=y'
	%endif
	echo 'MATH_EMULATION=n'
	%endif
%endif
}

# generate .config and kernel.conf
pykconfig > %{objdir}/.kernel-autogen.conf
%{__make} pykconfig

# build kernel
%{__make} all

# build reverse config and show diff
%{__make} pykconfig
diff -u %{_sourcedir}/kernel-vanilla-multiarch.conf %{objdir}/kernel.conf || :
%endif # arch build

%install
rm -rf $RPM_BUILD_ROOT
# touch for noarch build (exclude list)
install -d $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
touch $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/{utsrelease,version,autoconf-dist}.h

%if %{without noarch}
%{__make} %{MakeOpts} %{!?with_verbose:-s} modules_install \
	-C %{objdir} \
	%{?with_verbose:V=1} \
	DEPMOD=%{DepMod} \
	INSTALL_MOD_PATH=$RPM_BUILD_ROOT \
	KERNELRELEASE=%{kernel_release}

mkdir $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/misc
rm -f $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/{build,source}
touch $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/{build,source}

# /boot
install -d $RPM_BUILD_ROOT/boot
cp -a %{objdir}/System.map $RPM_BUILD_ROOT/boot/System.map-%{kernel_release}
install %{objdir}/vmlinux $RPM_BUILD_ROOT/boot/vmlinux-%{kernel_release}
%ifarch %{ix86} %{x8664}
cp -a %{objdir}/arch/%{target_arch_dir}/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%endif
%ifarch ppc ppc64
install %{objdir}/vmlinux $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%endif
%ifarch alpha sparc sparc64
	%{__gzip} -cfv %{objdir}/vmlinux > %{objdir}/vmlinuz
	cp -a %{objdir}/vmlinuz $RPM_BUILD_ROOT/boot/vmlinuz-%{kernel_release}
%ifarch sparc
	elftoaout %{objdir}/arch/sparc/boot/image -o %{objdir}/vmlinux.aout
	install %{objdir}/vmlinux.aout $RPM_BUILD_ROOT/boot/vmlinux.aout-%{kernel_release}
%endif
%ifarch sparc64
	elftoaout %{objdir}/arch/sparc64/boot/image -o %{objdir}/vmlinux.aout
	install %{objdir}/vmlinux.aout $RPM_BUILD_ROOT/boot/vmlinux.aout-%{kernel_release}
%endif
%endif

# for initrd
touch $RPM_BUILD_ROOT/boot/initrd-%{kernel_release}.gz

%if "%{_target_base_arch}" != "%{_arch}"
touch $RPM_BUILD_ROOT/lib/modules/%{kernel_release}/modules.dep
%endif

# /etc/modrobe.d
install -d $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{kernel_release}

# /usr/src/linux
# maybe package these to -module-build, then -headers could be noarch
cp -a %{objdir}/Module.symvers $RPM_BUILD_ROOT%{_kernelsrcdir}/Module.symvers-dist
cp -aL %{objdir}/.config $RPM_BUILD_ROOT%{_kernelsrcdir}/config-dist
cp -a %{objdir}/include/linux/autoconf.h $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/autoconf-dist.h
cp -a %{objdir}/include/linux/{utsrelease,version}.h $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux
%endif # arch dependant

%if %{with noarch}
# test if we can hardlink -- %{_builddir} and $RPM_BUILD_ROOT on same partition
if cp -al %{srcdir}/COPYING $RPM_BUILD_ROOT/COPYING 2>/dev/null; then
	l=l
	rm -f $RPM_BUILD_ROOT/COPYING
fi
cp -a$l %{srcdir}/* $RPM_BUILD_ROOT%{_kernelsrcdir}

install -d $RPM_BUILD_ROOT/lib/modules/%{kernel_release}
cp -a %{SOURCE6} $RPM_BUILD_ROOT%{_kernelsrcdir}/include/linux/config.h
%endif # arch independant

# collect module-build files and directories
# Usage: kernel-module-build.pl $rpmdir $fileoutdir
fileoutdir=$(pwd)
cd $RPM_BUILD_ROOT%{_kernelsrcdir}
%{objdir}/scripts/kernel-module-build.pl %{_kernelsrcdir} $fileoutdir
cd -

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ -x /sbin/new-kernel-pkg ]; then
	/sbin/new-kernel-pkg --remove %{kernel_release}
fi

%post
mv -f /boot/vmlinuz-%{alt_kernel} /boot/vmlinuz-%{alt_kernel}.old 2> /dev/null > /dev/null
mv -f /boot/System.map-%{alt_kernel} /boot/System.map-%{alt_kernel}.old 2> /dev/null > /dev/null
ln -sf vmlinuz-%{kernel_release} /boot/vmlinuz-%{alt_kernel}
ln -sf System.map-%{kernel_release} /boot/System.map-%{alt_kernel}
if [ ! -e /boot/vmlinuz ]; then
	mv -f /boot/vmlinuz /boot/vmlinuz.old 2> /dev/null > /dev/null
	mv -f /boot/System.map /boot/System.map.old 2> /dev/null > /dev/null
	ln -sf vmlinuz-%{kernel_release} /boot/vmlinuz
	ln -sf System.map-%{alt_kernel} /boot/System.map
	mv -f %{initrd_dir}/initrd %{initrd_dir}/initrd.old 2> /dev/null > /dev/null
	ln -sf initrd-%{alt_kernel} %{initrd_dir}/initrd
fi

%depmod %{kernel_release}

/sbin/geninitrd -f --initrdfs=rom %{initrd_dir}/initrd-%{kernel_release}.gz %{kernel_release}
mv -f %{initrd_dir}/initrd-%{alt_kernel} %{initrd_dir}/initrd-%{alt_kernel}.old 2> /dev/null > /dev/null
ln -sf initrd-%{kernel_release}.gz %{initrd_dir}/initrd-%{alt_kernel}

if [ -x /sbin/new-kernel-pkg ]; then
	if [ -f /etc/pld-release ]; then
		title=$(sed 's/^[0-9.]\+ //' < /etc/pld-release)
	else
		title='PLD Linux'
	fi

	title="$title %{alt_kernel}"

	/sbin/new-kernel-pkg --initrdfile=%{initrd_dir}/initrd-%{kernel_release}.gz --install %{kernel_release} --banner "$title"
elif [ -x /sbin/rc-boot ]; then
	/sbin/rc-boot 1>&2 || :
fi

%post vmlinux
mv -f /boot/vmlinux-%{alt_kernel} /boot/vmlinux-%{alt_kernel}.old 2> /dev/null > /dev/null
ln -sf vmlinux-%{kernel_release} /boot/vmlinux-%{alt_kernel}

%post drm
%depmod %{kernel_release}

%postun drm
%depmod %{kernel_release}

%post pcmcia
%depmod %{kernel_release}

%postun pcmcia
%depmod %{kernel_release}

%post sound-alsa
%depmod %{kernel_release}

%postun sound-alsa
%depmod %{kernel_release}

%post sound-oss
%depmod %{kernel_release}

%postun sound-oss
%depmod %{kernel_release}

%post headers
rm -f %{_prefix}/src/linux-%{alt_kernel}
ln -snf %{basename:%{_kernelsrcdir}} %{_prefix}/src/linux-%{alt_kernel}

%postun headers
if [ "$1" = "0" ]; then
	if [ -L %{_prefix}/src/linux-%{alt_kernel} ]; then
		if [ "$(readlink %{_prefix}/src/linux-%{alt_kernel})" = "linux-%{version}_%{alt_kernel}" ]; then
			rm -f %{_prefix}/src/linux-%{alt_kernel}
		fi
	fi
fi

%triggerin module-build -- %{name} = %{epoch}:%{version}-%{release}
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/build
ln -sfn %{_kernelsrcdir} /lib/modules/%{kernel_release}/source

%triggerun module-build -- %{name} = %{epoch}:%{version}-%{release}
if [ "$1" = 0 ]; then
	rm -f /lib/modules/%{kernel_release}/{build,source}
fi

%if %{without noarch}
%files
%defattr(644,root,root,755)
%ifarch sparc sparc64
/boot/vmlinux.aout-%{kernel_release}
%endif
/boot/vmlinuz-%{kernel_release}
/boot/System.map-%{kernel_release}
%ghost /boot/initrd-%{kernel_release}.gz
%dir /lib/modules/%{kernel_release}
%dir /lib/modules/%{kernel_release}/kernel
/lib/modules/%{kernel_release}/kernel/arch
/lib/modules/%{kernel_release}/kernel/crypto
/lib/modules/%{kernel_release}/kernel/drivers
%if %{have_drm}
%exclude /lib/modules/%{kernel_release}/kernel/drivers/char/drm
%endif
/lib/modules/%{kernel_release}/kernel/fs
/lib/modules/%{kernel_release}/kernel/kernel
/lib/modules/%{kernel_release}/kernel/lib
/lib/modules/%{kernel_release}/kernel/net
%dir /lib/modules/%{kernel_release}/kernel/sound
/lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%if %{have_sound}
%ifnarch sparc sparc64
%exclude /lib/modules/%{kernel_release}/kernel/drivers/media/video/*/*-alsa.ko*
%endif
%endif
%dir /lib/modules/%{kernel_release}/misc
%if %{have_pcmcia}
%exclude /lib/modules/%{kernel_release}/kernel/drivers/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
%exclude /lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
%exclude /lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
%endif
%ghost /lib/modules/%{kernel_release}/modules.*
%ghost /lib/modules/%{kernel_release}/build
%ghost /lib/modules/%{kernel_release}/source

%dir %{_sysconfdir}/modprobe.d/%{kernel_release}

%ifarch alpha %{ix86} %{x8664} ppc ppc64 sparc sparc64
%files vmlinux
%defattr(644,root,root,755)
/boot/vmlinux-%{kernel_release}
%endif

%if %{have_drm}
%files drm
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/char/drm
%endif

%if %{have_pcmcia}
%files pcmcia
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/drivers/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/*/pcmcia
/lib/modules/%{kernel_release}/kernel/drivers/bluetooth/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/ide/legacy/ide-cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/isdn/hardware/avm/avm_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/*_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/net/wireless/hostap/hostap_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/parport/parport_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/serial/serial_cs.ko*
/lib/modules/%{kernel_release}/kernel/drivers/telephony/ixj_pcmcia.ko*
/lib/modules/%{kernel_release}/kernel/drivers/usb/host/sl811_cs.ko*
/lib/modules/%{kernel_release}/kernel/sound/pcmcia
%endif

%if %{have_sound}
%files sound-alsa
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound
%exclude %dir /lib/modules/%{kernel_release}/kernel/sound
%exclude /lib/modules/%{kernel_release}/kernel/sound/soundcore.*
%if %{have_oss}
%exclude /lib/modules/%{kernel_release}/kernel/sound/oss
%endif
%if %{have_pcmcia}
%exclude /lib/modules/%{kernel_release}/kernel/sound/pcmcia
%endif

%if %{have_oss}
%files sound-oss
%defattr(644,root,root,755)
/lib/modules/%{kernel_release}/kernel/sound/oss
%endif			# %{have_oss}
%endif			# %{have_sound}

%files config
%defattr(644,root,root,755)
%dir %{_kernelsrcdir}
%{_kernelsrcdir}/config-dist
%{_kernelsrcdir}/Module.symvers-dist
%dir %{_kernelsrcdir}/include
%dir %{_kernelsrcdir}/include/linux
%{_kernelsrcdir}/include/linux/autoconf-dist.h
%{_kernelsrcdir}/include/linux/utsrelease.h
%{_kernelsrcdir}/include/linux/version.h
%endif # noarch package

%if %{with noarch}
%files headers
%defattr(644,root,root,755)
%{_kernelsrcdir}/include/*
%exclude %dir %{_kernelsrcdir}/include/linux
%exclude %{_kernelsrcdir}/include/linux/autoconf-dist.h
%exclude %{_kernelsrcdir}/include/linux/utsrelease.h
%exclude %{_kernelsrcdir}/include/linux/version.h

%files module-build -f aux_files
%defattr(644,root,root,755)
%{_kernelsrcdir}/Kbuild
%{_kernelsrcdir}/arch/*/kernel/asm-offsets*
%{_kernelsrcdir}/arch/*/kernel/sigframe.h
%{_kernelsrcdir}/arch/x86/kernel/sigframe_32.h
%dir %{_kernelsrcdir}/scripts
%dir %{_kernelsrcdir}/scripts/kconfig
%{_kernelsrcdir}/scripts/Kbuild.include
%{_kernelsrcdir}/scripts/Makefile*
%{_kernelsrcdir}/scripts/basic
%{_kernelsrcdir}/scripts/mkmakefile
%{_kernelsrcdir}/scripts/mod
%{_kernelsrcdir}/scripts/setlocalversion
%{_kernelsrcdir}/scripts/*.c
%{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/scripts/kconfig/*

%files doc
%defattr(644,root,root,755)
%{_kernelsrcdir}/Documentation

%files source -f aux_files_exc
%defattr(644,root,root,755)
%{_kernelsrcdir}/arch/*/[!Mk]*
%{_kernelsrcdir}/arch/*/kernel/[!M]*
%exclude %{_kernelsrcdir}/arch/*/kernel/asm-offsets*
%exclude %{_kernelsrcdir}/arch/*/kernel/sigframe.h
%exclude %{_kernelsrcdir}/arch/x86/kernel/sigframe_32.h
%{_kernelsrcdir}/block
%{_kernelsrcdir}/crypto
%{_kernelsrcdir}/drivers
%{_kernelsrcdir}/fs
%{_kernelsrcdir}/init
%{_kernelsrcdir}/ipc
%{_kernelsrcdir}/kernel
%{_kernelsrcdir}/lib
%{_kernelsrcdir}/mm
%{_kernelsrcdir}/net
%{_kernelsrcdir}/scripts/*
%{_kernelsrcdir}/samples
%exclude %{_kernelsrcdir}/scripts/Kbuild.include
%exclude %{_kernelsrcdir}/scripts/Makefile*
%exclude %{_kernelsrcdir}/scripts/basic
%exclude %{_kernelsrcdir}/scripts/kconfig
%exclude %{_kernelsrcdir}/scripts/mkmakefile
%exclude %{_kernelsrcdir}/scripts/mod
%exclude %{_kernelsrcdir}/scripts/setlocalversion
%exclude %{_kernelsrcdir}/scripts/*.c
%exclude %{_kernelsrcdir}/scripts/*.sh
%{_kernelsrcdir}/sound
%{_kernelsrcdir}/security
%{_kernelsrcdir}/usr
%{_kernelsrcdir}/COPYING
%{_kernelsrcdir}/CREDITS
%{_kernelsrcdir}/MAINTAINERS
%{_kernelsrcdir}/README
%{_kernelsrcdir}/REPORTING-BUGS
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: kernel-vanilla.spec,v $
Revision 1.135  2008-03-31 22:02:14  glen
- show reverse config after build

Revision 1.134  2008-03-27 17:06:52  glen
- 2.6.24.4

Revision 1.133  2008-02-28 18:24:22  deejay1
- added sigframe_32.h to module-build package (part of the x86* merge)
- rel. 2

Revision 1.132  2008-02-28 15:56:14  glen
- 2.6.24.3

Revision 1.131  2008-02-26 23:04:40  glen
- rel 1: sending to th

Revision 1.130  2008-02-24 13:28:39  glen
- move dirs for %{_kernelsrcdir}/include/linux to -config package to avoid loops

Revision 1.129  2008-02-12 23:07:19  glen
- use manually incremented vermagic between main kernel and module pkg deps

Revision 1.128  2008-02-12 21:28:51  glen
- package {utsrelease,version}.h
- rpmbuild macros needed which understand our -config subpackage

Revision 1.127  2008-02-12 08:33:06  glen
- R: /sbin/depmod, due vserver-packages having provide on module-init-tools

Revision 1.126  2008-02-12 01:40:20  glen
- add triggerun to remove symlinks (avoid dead links)

Revision 1.125  2008-02-12 01:09:29  glen
- arch vs noarch packaging

Revision 1.124  2008-02-12 00:49:49  glen
- keep same name for src.rpm, i wonder if it will work with builders

Revision 1.123  2008-02-11 22:47:01  glen
- {build,source} symlinks as ghost and package to main package (parent dir and uninstall ordering)
- symlinks really are created in module-build trigger

Revision 1.122  2008-02-11 19:53:22  glen
- build source in second run as noarch (plus builder hacks)

Revision 1.121  2008-02-11 18:56:47  glen
- put .config and Module.symvers to -config (arch specific)

Revision 1.120  2008-02-11 18:50:45  glen
- move config-dist and Module.symvers-dist to -module-build package (they are not headers)

Revision 1.119  2008-02-11 13:44:24  glen
- 2.6.24.2

Revision 1.118  2008-02-09 17:04:37  glen
- builds with gcc 3.3.6 on ac-ppc (with -mcpu=440 patch)

Revision 1.117  2008-02-09 16:36:06  qboosh
- i[34]86 should support i586 (F00F bug) too

Revision 1.116  2008-02-09 16:17:57  glen
- X86_F00F_BUG=y

Revision 1.115  2008-02-09 16:14:09  glen
- M686=y only in i386

Revision 1.114  2008-02-09 16:01:37  glen
- update to athlon

Revision 1.113  2008-02-09 15:37:37  glen
- ppc builds now on ac thx to hints by sparky

Revision 1.112  2008-02-08 21:35:17  glen
- 2.6.24.1

Revision 1.111  2008-02-07 13:25:08  glen
- use %kgcc, %kgcc_package

Revision 1.110  2008-02-07 13:15:45  glen
- gcc requirement is actually for ppc (-mcpu=440)

Revision 1.109  2008-02-07 13:04:55  glen
- more df friendly

Revision 1.108  2008-02-07 13:01:30  glen
- distfiles friendly, renum sources

Revision 1.107  2008-02-07 12:39:53  glen
- gcc4 bcond

Revision 1.106  2008-02-06 00:58:50  glen
- sparc files fix

Revision 1.105  2008-02-06 00:56:27  glen
- %files for sparc

Revision 1.104  2008-02-06 00:15:23  glen
- too much copy-paste

Revision 1.103  2008-02-06 00:14:49  glen
- install part added for sparc, alpha and ppc64

Revision 1.102  2008-02-06 00:06:54  glen
- cleanups, add drm subpackage, vmlinux pkg not on every arch

Revision 1.101  2008-02-06 00:03:28  glen
- init vars

Revision 1.100  2008-02-05 23:58:39  glen
- parse error

Revision 1.99  2008-02-05 23:56:50  glen
- no pcmcia,drm,oss on sparc
- no isa on alpha

Revision 1.98  2008-02-05 23:29:35  glen
- hide autogenerated file

Revision 1.97  2008-02-05 23:26:32  glen
- updated to makefile

Revision 1.96  2008-02-05 20:50:41  glen
- cosmetics

Revision 1.95  2008-02-05 20:33:18  glen
- remove debug

Revision 1.94  2008-02-05 16:49:48  glen
- add sparc

Revision 1.93  2008-02-04 22:06:13  glen
- enable alpha arch

Revision 1.92  2008-02-04 21:39:33  glen
- pass makeopts

Revision 1.91  2008-02-04 21:31:01  glen
- rules part of multiarch makefile moved to sources

Revision 1.90  2008-01-31 21:30:19  glen
- update from kernel:LINUX_2_6 (qboosh):
  arch/x86/kernel/asm-offsets_{32,64}.c needed in -module-build

Revision 1.89  2008-01-31 17:59:24  glen
- still get rid of .gitignore fikes

Revision 1.88  2008-01-30 00:49:15  glen
- typo

Revision 1.87  2008-01-30 00:39:11  glen
- fix initial build

Revision 1.86  2008-01-30 00:26:31  glen
- noautochrpath kernel sourcedir

Revision 1.85  2008-01-30 00:24:51  glen
- move the pykconfig to local Makefile for better dependency

Revision 1.84  2008-01-30 00:21:26  glen
- update install part to take files from objdir

Revision 1.83  2008-01-29 23:01:02  glen
- build outside sourcedir

Revision 1.82  2008-01-29 21:34:33  glen
- build and source symlinks packaged

Revision 1.81  2008-01-29 18:17:57  glen
- drop kernel provides, update internal deps

Revision 1.80  2008-01-29 18:15:08  glen
- missing epoch for udev

Revision 1.79  2008-01-29 18:14:41  glen
- remove version macros, only in one place they are in use

Revision 1.78  2008-01-29 18:11:36  glen
- skip build and source symlinks from packaging

Revision 1.77  2008-01-29 18:04:10  glen
- aux files created on repackage, so just remove them

Revision 1.76  2008-01-29 16:24:14  glen
- install cleanup

Revision 1.75  2008-01-29 14:15:46  glen
- patch Makefile for now

Revision 1.74  2008-01-29 14:10:18  glen
- skip regen if spec produced config is same as previous

Revision 1.73  2008-01-29 14:00:47  glen
- integrate the python config into kernel Makefile

Revision 1.72  2008-01-28 23:34:10  glen
- path for kernel-vanilla-multiarch.conf

Revision 1.71  2008-01-28 23:24:37  glen
- produce new kernel config from generated one

Revision 1.70  2008-01-28 22:19:59  glen
- netfilter config merged to multiarch config

Revision 1.69  2008-01-28 20:18:54  glen
- kernel-config.py was added as non-executale to cvs

Revision 1.68  2008-01-28 18:41:44  glen
- only multiarch configs

Revision 1.67  2008-01-28 18:29:20  glen
- global replace is better

Revision 1.66  2008-01-28 18:28:03  glen
- follow kernel.spec changes

Revision 1.65  2008-01-28 17:39:11  glen
- update multiarch.py mode

Revision 1.64  2008-01-28 15:48:46  glen
- only smp, no up/smp

Revision 1.63  2008-01-28 15:27:48  glen
- ix86, x86_64 arch dirs got merged in source

Revision 1.62  2008-01-28 15:06:39  glen
- start 2.6.24
